/*
 * logger.h
 *
 *  Created on: 2011/04/11
 *      Author: shu
 */

#ifndef LOGGER_H_
#define LOGGER_H_

#include <iostream>
#include <ostream>
#include <string>

using namespace std;

class Logger {
public:

  static Logger* GetInstance() {
    static Logger instance;
    return &instance;
 }

  void ErrorLog(string message) {
#pragma omp critical(lock_)
    cout << "error : " << message << endl;
  }

  void WarningLog(string message) {
#pragma omp critical(lock_)
    cout << "warning : " << message << endl;
  }

  void Log(string message) {
#pragma omp critical(lock_)
    cout << message << endl;
  }

private:
  Logger()
  {
  }
  ~Logger() {
  }
  Logger(const Logger& rhs);
  Logger operator=(const Logger& rhs);
};

#endif /* LOGGER_H_ */
