/*
 * score_matrix_reader.h
 *
 *  Created on: 2010/06/22
 *      Author: shu
 */

#ifndef SCORE_MATRIX_READER_H_
#define SCORE_MATRIX_READER_H_

#include <fstream>
#include <string>
#include <iostream>
#include <fstream>
#include <list>
#include "encoder.h"

using namespace std;

class ScoreMatrix;

class ScoreMatrixReader {
public:
  ScoreMatrixReader(const Encoder &encoder);

  virtual ~ScoreMatrixReader();

  ScoreMatrix Read(const string &filename);
  ScoreMatrix ReadDefault();

private:
  static const string default_matrix_;
  static const string default_matrix_name_;

  list<string> Split(string str, string delim);
  int GetNumberLetters();
  int GetMatrixSize();
  void Parse(istream &in, int *matrix);
  string GetName(const string &filename);

  Encoder encoder_;
};

#endif /* SCORE_MATRIX_READER_H_ */
