/*
 * encoder_test.cpp
 *
 *  Created on: 2010/09/12
 *      Author: shu
 */

#include <gtest/gtest.h>
#include <string>
#include <stdint.h>
#include "../src/sequence.h"
#include "../src/encoder.h"
#include "../src/sequence_type.h"
#include "../src/protein_type.h"

using namespace std;

TEST(EncoderTest, Encode)
{
  string seq("arndcqeghilkmfpstwyvbjz*x");
  uint32_t seq_length = seq.length();
  uint8_t coded_sequence[seq.length()];
  ProteinType protein;
  Encoder encoder( protein );

  EXPECT_EQ(9, encoder.Encode('i'));
  encoder.Encode(seq,coded_sequence);

  for (uint32_t i = 0; i < seq_length; ++i) {
    EXPECT_EQ(i, static_cast<uint32_t>(coded_sequence[i]));
  }
}

